//
//  BNCamera.h
//  Camera
//
//  Created by Ravil on 15.08.13.
//  Copyright (c) 2013 bossnote. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <AVFoundation/AVFoundation.h>
#import <ImageIO/CGImageProperties.h>

typedef enum {
    simplePhoto,
    video,
    document
} BNCameraType;


@interface BNCamera : NSObject <AVCaptureFileOutputRecordingDelegate>{
    AVCaptureSession *session;
    AVCaptureStillImageOutput * stillImageOutput;
    AVCaptureMovieFileOutput * movieOutput;
    AVCaptureVideoPreviewLayer *captureVideoPreviewLayer;
    AVCaptureConnection *videoConnection;
    AVCaptureDevice * captureDevice;
    CALayer * mainLayer;
    NSString * currPreset;

    CGFloat scaleFactor, beginScale;
    
    dispatch_queue_t changeModQueue;
}

@property (nonatomic, readwrite) BNCameraType currentType;
@property (nonatomic, readwrite) AVCaptureDevicePosition currentPosition;
@property (nonatomic, readwrite) BOOL isRecordingVideo;

- (void)createCameraWithType:(BNCameraType)type toLayer:(CALayer*)parrentLayer;
- (void)changeType:(BNCameraType)type;
- (void)reinitCamera;
- (void)zoomCameraWithGesture:(UIPinchGestureRecognizer*)gesture;
- (void)flipCamera;
- (void)setFocusPoint:(CGPoint)point;
- (void)setFlashMode:(AVCaptureFlashMode)mode;
- (void)capturePhoto;
- (void)startVideoRecord;
- (void)stopVideoRecord;
- (void)setOrientation:(UIDeviceOrientation)orientation;
- (NSString*)createFilePath;

@end
